Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! ------------------
-!
+! routine pmci_update_new removed,
+! pmc_get_local_model_info renamed pmc_get_model_info, some keywords also
+! renamed,
+! filling up redundant ghost points introduced,
+! some index bound variables renamed,
+! further formatting cleanup
 !
 ! Former revisions:
@@ -111,5 +116,5 @@
 
     USE pmc_handle_communicator,                                               &
-        ONLY:  pmc_get_local_model_info, pmc_init_model, pmc_is_rootmodel,     &
+        ONLY:  pmc_get_model_info, pmc_init_model, pmc_is_rootmodel,           &
                pmc_no_namelist_found, pmc_server_for_client
 
@@ -128,155 +133,151 @@
     IMPLICIT NONE
 
-!-- TO_DO: a lot of lines (including comments) in this file exceed the 80 char
-!--        limit. Try to reduce as much as possible
-
-!-- TO_DO: are all of these variables following now really PUBLIC?
-!--        Klaus and I guess they are not
-    PRIVATE    !:  Note that the default publicity is here set to private.
+    PRIVATE
 
 !
 !-- Constants
-    INTEGER(iwp), PARAMETER, PUBLIC ::  client_to_server = 2   !:
-    INTEGER(iwp), PARAMETER, PUBLIC ::  server_to_client = 1   !:
+    INTEGER(iwp), PARAMETER ::  client_to_server = 2   !:
+    INTEGER(iwp), PARAMETER ::  server_to_client = 1   !:
 
 !
 !-- Coupler setup
-    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_id  = 1            !:
-    CHARACTER(LEN=32), PUBLIC, SAVE ::  cpl_name               !:
-    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_npe_total          !:
-    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_parent_id          !:
+    INTEGER(iwp), SAVE      ::  cpl_id  = 1            !:
+    CHARACTER(LEN=32), SAVE ::  cpl_name               !:
+    INTEGER(iwp), SAVE      ::  cpl_npe_total          !:
+    INTEGER(iwp), SAVE      ::  cpl_parent_id          !:
 
 !
 !-- Control parameters, will be made input parameters later
-    CHARACTER(LEN=7), PUBLIC, SAVE ::  nesting_mode = 'two-way'  !: steering parameter for one- or two-way nesting
-
-    LOGICAL, PUBLIC, SAVE ::  nested_run = .FALSE.  !: general switch if nested run or not
-
-    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_l = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_r = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_s = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_n = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_t = -1.0_wp   !:
+    CHARACTER(LEN=7), SAVE ::  nesting_mode = 'two-way'  !: steering parameter
+                                                         !: for 1- or 2-way nesting
+
+    LOGICAL, SAVE ::  nested_run = .FALSE.  !: general switch
+
+    REAL(wp), SAVE ::  anterp_relax_length_l = -1.0_wp   !:
+    REAL(wp), SAVE ::  anterp_relax_length_r = -1.0_wp   !:
+    REAL(wp), SAVE ::  anterp_relax_length_s = -1.0_wp   !:
+    REAL(wp), SAVE ::  anterp_relax_length_n = -1.0_wp   !:
+    REAL(wp), SAVE ::  anterp_relax_length_t = -1.0_wp   !:
 
 !
 !-- Geometry
-    REAL(wp), PUBLIC, SAVE                    ::  area_t               !:
+    REAL(wp), SAVE                            ::  area_t               !:
     REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE ::  coord_x              !:
     REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE ::  coord_y              !:
-    REAL(wp), PUBLIC, SAVE                    ::  lower_left_coord_x   !:
-    REAL(wp), PUBLIC, SAVE                    ::  lower_left_coord_y   !:
+    REAL(wp), SAVE                            ::  lower_left_coord_x   !:
+    REAL(wp), SAVE                            ::  lower_left_coord_y   !:
 
 !
 !-- Client coarse data arrays
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  ec   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  ptc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  uc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  vc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  wc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  qc   !:
-
-    INTEGER(iwp), DIMENSION(5)                          ::  coarse_bound   !:
-    REAL(wp), PUBLIC, SAVE                              ::  xexl           !:
-    REAL(wp), PUBLIC, SAVE                              ::  xexr           !:
-    REAL(wp), PUBLIC, SAVE                              ::  yexs           !:
-    REAL(wp), PUBLIC, SAVE                              ::  yexn           !:
-    REAL(wp), PUBLIC, SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_l    !:
-    REAL(wp), PUBLIC, SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_n    !:
-    REAL(wp), PUBLIC, SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_r    !:
-    REAL(wp), PUBLIC, SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_s    !:
-    REAL(wp), PUBLIC, SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !:
-
-!
-!-- Client interpolation coefficients and client-array indices to be precomputed and stored.
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jco    !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jcv    !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xu   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xu   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yv   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yv   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zo   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !:
-
-!
-!-- Client index arrays and log-ratio arrays for the log-law near-wall corrections.
-!-- These are not truly 3-D arrays but multiply 2-D arrays.
-    INTEGER(iwp), PUBLIC, SAVE :: ncorr  !: ncorr is the 4th dimension of the log_ratio-arrays
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_l   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_n   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_r   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_s   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_l   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_n   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_r   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_s   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_l   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_n   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_r   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_s   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_l   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_n   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_r   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_s   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_l   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_n   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_r   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_s   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_l   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_n   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_r   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !:
+    INTEGER(iwp), DIMENSION(5)                  ::  coarse_bound   !:
+
+    REAL(wp), SAVE                              ::  xexl           !:
+    REAL(wp), SAVE                              ::  xexr           !:
+    REAL(wp), SAVE                              ::  yexs           !:
+    REAL(wp), SAVE                              ::  yexn           !:
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_l    !:
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_n    !:
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_r    !:
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_s    !:
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !:
+
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec   !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc  !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  uc   !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vc   !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc   !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc   !:
+
+!
+!-- Client interpolation coefficients and client-array indices to be precomputed
+!-- and stored.
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jco    !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jcv    !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xu   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xu   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yv   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yv   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zo   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !:
+
+!
+!-- Client index arrays and log-ratio arrays for the log-law near-wall
+!-- corrections. These are not truly 3-D arrays but multiple 2-D arrays.
+    INTEGER(iwp), SAVE :: ncorr  !: 4th dimension of the log_ratio-arrays
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_l   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_n   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_r   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_s   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_l   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_n   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_r   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_s   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_l   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_n   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_r   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_s   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_l   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_n   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_r   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_s   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_l   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_n   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_r   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_s   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_l   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_n   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_r   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !:
 
 !
 !-- Upper bounds for k in anterpolation.
-    INTEGER(iwp), PUBLIC, SAVE ::  kceu   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  kcew   !:
+    INTEGER(iwp), SAVE ::  kctu   !:
+    INTEGER(iwp), SAVE ::  kctw   !:
 
 !
 !-- Upper bound for k in log-law correction in interpolation.
-    INTEGER(iwp), PUBLIC, SAVE ::  nzt_topo_nestbc_l   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nzt_topo_nestbc_n   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nzt_topo_nestbc_r   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nzt_topo_nestbc_s   !:
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_l   !:
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_n   !:
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_r   !:
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_s   !:
 
 !
 !-- Number of ghost nodes in coarse-grid arrays for i and j in anterpolation.
-    INTEGER(iwp), PUBLIC, SAVE ::  nhll   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nhlr   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nhls   !:
-    INTEGER(iwp), PUBLIC, SAVE ::  nhln   !:
+    INTEGER(iwp), SAVE ::  nhll   !:
+    INTEGER(iwp), SAVE ::  nhlr   !:
+    INTEGER(iwp), SAVE ::  nhls   !:
+    INTEGER(iwp), SAVE ::  nhln   !:
 
 !
 !-- Spatial under-relaxation coefficients for anterpolation.
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  frax   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  fray   !:
-    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  fraz   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  frax   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fray   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fraz   !:
 
 !
 !-- Client-array indices to be precomputed and stored for anterpolation.
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  iflu   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuu   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  iflo   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuo   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jflv   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuv   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jflo   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuo   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kflw   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuw   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kflo   !:
-    INTEGER(iwp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuo   !:
-
-!
-!-- Module private variables.
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflu   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuu   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflv   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuv   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflw   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuw   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuo   !:
+
     INTEGER(iwp), DIMENSION(3)          ::  define_coarse_grid_int    !:
     REAL(wp), DIMENSION(7)              ::  define_coarse_grid_real   !:
@@ -301,5 +302,5 @@
     END TYPE coarsegrid_def
                                           
-    TYPE(coarsegrid_def), SAVE             ::  cg   !:
+    TYPE(coarsegrid_def), SAVE ::  cg   !:
 
 
@@ -340,8 +341,8 @@
     END INTERFACE pmci_set_swaplevel
 
-    INTERFACE pmci_update_new
-       MODULE PROCEDURE pmci_update_new
-    END INTERFACE
-
+    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                       &
+           anterp_relax_length_s, anterp_relax_length_n,                       &
+           anterp_relax_length_t, client_to_server, cpl_id, nested_run,        &
+           nesting_mode, server_to_client
     PUBLIC pmci_client_datatrans
     PUBLIC pmci_client_initialize
@@ -354,5 +355,4 @@
     PUBLIC pmci_server_synchronize
     PUBLIC pmci_set_swaplevel
-    PUBLIC pmci_update_new
 
 
@@ -393,13 +393,11 @@
 !-- Get some variables required by the pmc-interface (and in some cases in the
 !-- PALM code out of the pmci) out of the pmc-core
-    CALL pmc_get_local_model_info( my_cpl_id = cpl_id,                         &
-                                   my_cpl_parent_id = cpl_parent_id,           &
-                                   cpl_name = cpl_name,                        &
-                                   npe_total = cpl_npe_total,                  &
-                                   lower_left_x = lower_left_coord_x,          &
-                                   lower_left_y = lower_left_coord_y )
+    CALL pmc_get_model_info( cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,   &
+                             cpl_name = cpl_name, npe_total = cpl_npe_total,   &
+                             lower_left_x = lower_left_coord_x,                &
+                             lower_left_y = lower_left_coord_y )
 !
 !-- Set the steering switch which tells the models that they are nested (of
-!-- course the root domain (cpl_id = 1 ) is not nested)
+!-- course the root domain (cpl_id = 1) is not nested)
     IF ( cpl_id >= 2 )  THEN
        nest_domain = .TRUE.
@@ -435,7 +433,14 @@
 
     CALL location_message( 'setup the nested model configuration', .FALSE. )
-    CALL pmci_setup_coordinates   !:  Compute absolute coordinates valid for all models
-    CALL pmci_setup_client        !:  Initialize PMC Client (Must be called before pmc_setup_server)
-    CALL pmci_setup_server        !:  Initialize PMC Server
+!
+!-- Compute absolute coordinates for all models
+    CALL pmci_setup_coordinates
+!
+!-- Initialize the client (must be called before pmc_setup_server)
+    CALL pmci_setup_client
+!
+!-- Initialize PMC Server
+    CALL pmci_setup_server
+
     CALL location_message( 'finished', .TRUE. )
 
@@ -449,22 +454,26 @@
     IMPLICIT NONE
 
-    INTEGER(iwp)               ::  client_id        !:
-    INTEGER(iwp)               ::  ierr             !:
-    INTEGER(iwp)               ::  i                !:
-    INTEGER(iwp)               ::  j                !:
-    INTEGER(iwp)               ::  k                !:
-    INTEGER(iwp)               ::  m                !:
-    INTEGER(iwp)               ::  nomatch          !:
-    INTEGER(iwp)               ::  nx_cl            !:
-    INTEGER(iwp)               ::  ny_cl            !:
-    INTEGER(iwp)               ::  nz_cl            !:
-    INTEGER(iwp), DIMENSION(5) ::  val              !:
-    REAL(wp), DIMENSION(1)     ::  fval             !:
-    REAL(wp)                   ::  dx_cl            !:
-    REAL(wp)                   ::  dy_cl            !:
-    REAL(wp)                   ::  xez              !:
-    REAL(wp)                   ::  yez              !:
-    CHARACTER(len=32)          ::  mychannel
-    CHARACTER(len=32)          ::  myname
+    CHARACTER(LEN=32) ::  myname
+
+    INTEGER(iwp) ::  client_id        !:
+    INTEGER(iwp) ::  ierr             !:
+    INTEGER(iwp) ::  i                !:
+    INTEGER(iwp) ::  j                !:
+    INTEGER(iwp) ::  k                !:
+    INTEGER(iwp) ::  m                !:
+    INTEGER(iwp) ::  nomatch          !:
+    INTEGER(iwp) ::  nx_cl            !:
+    INTEGER(iwp) ::  ny_cl            !:
+    INTEGER(iwp) ::  nz_cl            !:
+
+    INTEGER(iwp), DIMENSION(5) ::  val    !:
+
+    REAL(wp) ::  dx_cl            !:
+    REAL(wp) ::  dy_cl            !:
+    REAL(wp) ::  xez              !:
+    REAL(wp) ::  yez              !:
+
+    REAL(wp), DIMENSION(1) ::  fval             !:
+
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_x   !:
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_y   !:
@@ -472,5 +481,5 @@
 
 !
-!   Initialize the PMC server
+!   Initialize the pmc server
     CALL pmc_serverinit
 
@@ -478,4 +487,5 @@
 !-- Get coordinates from all clients
     DO  m = 1, SIZE( pmc_server_for_client ) - 1
+
        client_id = pmc_server_for_client(m)
        IF ( myid == 0 )  THEN        
@@ -510,5 +520,5 @@
           CALL pmc_recv_from_client( client_id, cl_coord_y, SIZE( cl_coord_y ),&
                                      0, 12, ierr )
-          WRITE ( 0, * )  'receive from pmc Client ', client_id, nx_cl, ny_cl
+!          WRITE ( 0, * )  'receive from pmc Client ', client_id, nx_cl, ny_cl
          
           define_coarse_grid_real(1) = lower_left_coord_x
@@ -529,8 +539,11 @@
           xez = ( nbgp + 1 ) * dx 
           yez = ( nbgp + 1 ) * dy 
-          IF ( cl_coord_x(0) < define_coarse_grid_real(1) + xez )          nomatch = 1 
-          IF ( cl_coord_x(nx_cl + 1) > define_coarse_grid_real(5) - xez )  nomatch = 1
-          IF ( cl_coord_y(0) < define_coarse_grid_real(2) + yez )          nomatch = 1 
-          IF ( cl_coord_y(ny_cl + 1) > define_coarse_grid_real(6) - yez )  nomatch = 1
+          IF ( ( cl_coord_x(0) < define_coarse_grid_real(1) + xez )       .OR. &
+               ( cl_coord_x(nx_cl+1) > define_coarse_grid_real(5) - xez ) .OR. &
+               ( cl_coord_y(0) < define_coarse_grid_real(2) + yez )       .OR. &
+               ( cl_coord_y(ny_cl+1) > define_coarse_grid_real(6) - yez ) )    &
+          THEN
+             nomatch = 1
+          ENDIF
 
           DEALLOCATE( cl_coord_x )
@@ -539,21 +552,23 @@
 !
 !--       Send coarse grid information to client
-          CALL pmc_send_to_client( client_id, Define_coarse_grid_real,         &
-                                   SIZE(define_coarse_grid_real), 0,           &
-                                   21, ierr )
-          CALL pmc_send_to_client( client_id, Define_coarse_grid_int,  3, 0,   &
+          CALL pmc_send_to_client( client_id, define_coarse_grid_real,         &
+                                   SIZE( define_coarse_grid_real ), 0, 21,     &
+                                   ierr )
+          CALL pmc_send_to_client( client_id, define_coarse_grid_int,  3, 0,   &
                                    22, ierr )
 
 !
 !--       Send local grid to client
-          CALL pmc_send_to_client( client_id, coord_x, nx+1+2*nbgp, 0, 24, ierr )
-          CALL pmc_send_to_client( client_id, coord_y, ny+1+2*nbgp, 0, 25, ierr )
+          CALL pmc_send_to_client( client_id, coord_x, nx+1+2*nbgp, 0, 24,     &
+                                   ierr )
+          CALL pmc_send_to_client( client_id, coord_y, ny+1+2*nbgp, 0, 25,     &
+                                   ierr )
 
 !
 !--       Also send the dzu-, dzw-, zu- and zw-arrays here
-          CALL pmc_send_to_client( client_id, dzu, nz_cl + 1, 0, 26, ierr )
-          CALL pmc_send_to_client( client_id, dzw, nz_cl + 1, 0, 27, ierr )
-          CALL pmc_send_to_client( client_id, zu,  nz_cl + 2, 0, 28, ierr )
-          CALL pmc_send_to_client( client_id, zw,  nz_cl + 2, 0, 29, ierr )
+          CALL pmc_send_to_client( client_id, dzu, nz_cl+1, 0, 26, ierr )
+          CALL pmc_send_to_client( client_id, dzw, nz_cl+1, 0, 27, ierr )
+          CALL pmc_send_to_client( client_id, zu,  nz_cl+2, 0, 28, ierr )
+          CALL pmc_send_to_client( client_id, zw,  nz_cl+2, 0, 29, ierr )
 
        ENDIF
@@ -567,9 +582,12 @@
       
        CALL MPI_BCAST( nz_cl, 1, MPI_INTEGER, 0, comm2d, ierr )
-       
+
+!
+!--    TO_DO: Klaus: please give a comment what is done here
        CALL pmci_create_index_list
 
 !
 !--    Include couple arrays into server content
+!--    TO_DO: Klaus: please give a more meaningful comment
        CALL pmc_s_clear_next_array_list
        DO  WHILE ( pmc_s_getnextarray( client_id, myname ) )
@@ -587,25 +605,27 @@
        IMPLICIT NONE
 
+       INTEGER(iwp) ::  i                  !:
+       INTEGER(iwp) ::  ic                 !:
+       INTEGER(iwp) ::  ierr               !:
+       INTEGER(iwp) ::  j                  !:
+       INTEGER(iwp) ::  k                  !:
+       INTEGER(iwp) ::  m                  !:
+       INTEGER(iwp) ::  n                  !:
+       INTEGER(iwp) ::  npx                !:
+       INTEGER(iwp) ::  npy                !:
+       INTEGER(iwp) ::  nrx                !:
+       INTEGER(iwp) ::  nry                !:
+       INTEGER(iwp) ::  px                 !:
+       INTEGER(iwp) ::  py                 !:
+       INTEGER(iwp) ::  server_pe          !:
+
+       INTEGER(iwp), DIMENSION(2) ::  scoord             !:
+       INTEGER(iwp), DIMENSION(2) ::  size_of_array      !:
+
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  coarse_bound_all   !:
-       INTEGER(iwp)                               ::  i                  !:
-       INTEGER(iwp)                               ::  ic                 !:
-       INTEGER(iwp)                               ::  ierr               !:
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  index_list         !:
-       INTEGER(iwp)                               ::  j                  !:
-       INTEGER(iwp)                               ::  k                  !:
-       INTEGER(iwp)                               ::  m                  !:
-       INTEGER(iwp)                               ::  n                  !:
-       INTEGER(iwp)                               ::  npx                !:
-       INTEGER(iwp)                               ::  npy                !:
-       INTEGER(iwp)                               ::  nrx                !:
-       INTEGER(iwp)                               ::  nry                !:
-       INTEGER(iwp)                               ::  px                 !:
-       INTEGER(iwp)                               ::  py                 !:
-       INTEGER(iwp), DIMENSION(2)                 ::  scoord             !:
-       INTEGER(iwp)                               ::  server_pe          !:
-       INTEGER(iwp), DIMENSION(2)                 ::  size_of_array      !:
-
 
        IF ( myid == 0 )  THEN
+!--       TO_DO: Klaus: give more specific comment what size_of_array stands for
           CALL pmc_recv_from_client( client_id, size_of_array, 2, 0, 40, ierr )
           ALLOCATE( coarse_bound_all(size_of_array(1),size_of_array(2)) )
@@ -628,11 +648,19 @@
           CALL MPI_COMM_SIZE( comm1dx, npx, ierr )
           CALL MPI_COMM_SIZE( comm1dy, npy, ierr )
-
-          nrx = nxr - nxl + 1   !  +1 in index because FORTRAN indexing starts with 1, palm with 0
+!
+!--       The +1 in index is because PALM starts with nx=0
+          nrx = nxr - nxl + 1
           nry = nyn - nys + 1
           ic  = 0
-          DO  k = 1, size_of_array(2)                                   !  loop over all client PEs
-             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)       !  area in y required by actual client PE
-                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)    !  area in x required by actual client PE
+!
+!--       Loop over all client PEs
+          DO  k = 1, size_of_array(2)
+!
+!--          Area along y required by actual client PE
+             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)
+!
+!--             Area along x required by actual client PE
+                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)
+
                    px = i / nrx
                    py = j / nry
@@ -642,16 +670,34 @@
                   
                    ic = ic + 1
-                   index_list(1,ic) = i - ( px * nrx ) + 1 + nbgp       !  First index in Server Array
-                   index_list(2,ic) = j - ( py * nry ) + 1 + nbgp       !  Second index in Server Array
-                   index_list(3,ic) = i - coarse_bound_all(1,k) + 1     !  x Index client coarse grid
-                   index_list(4,ic) = j - coarse_bound_all(3,k) + 1     !  y Index client coarse grid
-                   index_list(5,ic) = k - 1                             !  PE Number client
-                   index_list(6,ic) = server_pe                         !  PE Number server
+!
+!--                First index in server array
+                   index_list(1,ic) = i - ( px * nrx ) + 1 + nbgp
+!
+!--                Second index in server array
+                   index_list(2,ic) = j - ( py * nry ) + 1 + nbgp
+!
+!--                x index of client coarse grid
+                   index_list(3,ic) = i - coarse_bound_all(1,k) + 1
+!
+!--                y index of client coarse grid
+                   index_list(4,ic) = j - coarse_bound_all(3,k) + 1
+!
+!--                PE number of client
+                   index_list(5,ic) = k - 1
+!
+!--                PE number of server
+                   index_list(6,ic) = server_pe
+
                 ENDDO
              ENDDO
           ENDDO
+!
+!--       TO_DO: Klaus: comment what is done here
           CALL pmc_s_set_2d_index_list( client_id, index_list(:,1:ic) )
+
        ELSE
-          ALLOCATE( index_list(6,1) )    !  Dummy allocate
+!
+!--       TO_DO: Klaus: comment why thie dummy allocation is required
+          ALLOCATE( index_list(6,1) )
           CALL pmc_s_set_2d_index_list( client_id, index_list )
        ENDIF
